package msigi.loadconfig;

import java.io.*;

public class LoadConfig {

	private String configFileName;
	private String[] names;
	private String[] values;
	public final int MAXCONFIGPARAMS = 1024;

	public LoadConfig() {
	}

	public LoadConfig(String configFileNameIn) {
		setFileName(configFileNameIn);
	}

	public void setFileName(String configFileNameIn) {
		configFileName = configFileNameIn;
	}

	public void readFile() throws FileNotFoundException, IOException {
		int index = 0;
		BufferedReader in;
		String input;
		//System.out.println("Reading: " + configFileName);
		in = new BufferedReader(new FileReader(configFileName));
		names = new String[MAXCONFIGPARAMS];
		values = new String[MAXCONFIGPARAMS];
		while ((input = in.readLine()) != null) {
			//System.out.println("full line: " + input);
			input = input.trim();
			if ( (input.equals("")) || (input.charAt(0) == '#') ) {
				continue;
			}
			String[] tokens = input.split("=", 2);
			if (tokens.length < 2) {
				//System.out.println("Too few tokens");
			} else {
				tokens[0] = tokens[0].trim();
				tokens[1] = tokens[1].trim();
				//System.out.println("Name: " + tokens[0]);
				//System.out.println("Value: " + tokens[1]);
				if (index >= MAXCONFIGPARAMS) {
					throw (new IOException("Array is too small to store configuration"));
				}
				names[index] = tokens[0];
				values[index] = tokens[1];
				index++;
			}
			//System.out.print("\n");
		}
	}

	public String getParamByName(String paramName) {
		int index = 0;
		while (index < MAXCONFIGPARAMS) {
			if ( (names[index] == null) || (values[index] == null) ) {
				break;
			}
			//System.out.println(names[index] + ": " + values[index]);
			if (paramName.equals(names[index])) {
				return values[index];
			}
			index++;
		}
		return null;
	}

	public int getIntegerByName(String paramName) throws NumberFormatException {
		String intAsString;
		intAsString = getParamByName(paramName);
		if (intAsString == null) {
			throw (new NumberFormatException("Parameter not found"));
		}
		return Integer.parseInt(intAsString);
	}

	public void debugPrintArray() {
		int index = 0;
		while (index < MAXCONFIGPARAMS) {
			if ( (names[index] == null) || (values[index] == null) ) {
				break;
			}
			System.out.println(names[index] + ": " + values[index]);
			index++;
		}
	}

}
